<template>
  <div class="hello">
    <b-container>
      <div>
        <b-button v-b-toggle.collapse-4 class="m-1">Fecha</b-button>
        <b-collapse id="collapse-4">
          <b-card>
            <b-row>
              <b-col md="auto">
                <b-calendar required v-model="value" @context="onContext" locale="en-US"></b-calendar>
              </b-col>
            </b-row>
          </b-card>
        </b-collapse>
      </div>
      <v-for v-for="item in itemsMovie" :key="item.id">
        <b-card
          v-bind:img-src="item.img"
          img-alt="Card image"
          v-bind:title="item.name"
          img-top
          class="sm-1"
          v-bind:sub-title="item.duration"
        >
          <b-card-text>Reparto: {{item.cast}}</b-card-text>
          <b-card-text>Idiomas: {{item.idioms}}</b-card-text>
          <b-card-text>
            Horarios:
            <div class="mt-3">
              <b-button-group v-for="it in item.sh" size="sm" :key="it.hour">
                <b-button @click="openMovie(item,it.hour)">{{it.hour}}</b-button>
              </b-button-group>
            </div>
          </b-card-text>
        </b-card>
      </v-for>
    </b-container>
  </div>
</template>
<script>
import firebase from "firebase";
var dt = new Date();
export default {
  data() {
    return {
      value: dt.getFullYear() + '-' + (dt.getMonth() + 1) + '-' + dt.getDate(),
      context: null,
      itemsMovie: []
    };
  },
  created() {
    var db = firebase.firestore();
    db.collection("events").onSnapshot(querySnapshot => {
      querySnapshot.forEach(async doc => {
        var fc = await this.get_movie(doc.data().movie);
        var icast = "  ";
        var iidioms;
        var iimg;
        var iname;
        var isynopsis;
        var iduration;
        fc.forEach(element => {
          icast += element.cast + " ";
          iidioms = element.idioms;
          iimg = element.img;
          iname = element.name;
          (isynopsis = element.synopsis), (iduration = element.duration);
        });
        var json = {
          id: doc.id,
          cast: icast,
          idioms: iidioms,
          img: iimg,
          name: iname,
          synopsis: isynopsis,
          days: doc.data().days,
          sh: doc.data().sh,
          duration: iduration + " min"
        };
        //console.log(this.movi);
        this.itemsMovie.push(json);
      });
    });
  },
  methods: {
    onContext(ctx) {
      this.context = ctx;
    },
    openMovie(movie, hour) {
      let copy = movie;
      copy["date"] = this.value;
      copy["hr"] = hour;
      this.$router.push({
        name: "buy",
        params: {
          idMovie: copy
        }
      });
    },
    async get_movie(id) {
      var db = firebase.firestore();
      var rt = [];
      try {
        const resp = await db
          .collection("movies")
          .doc(id)
          .get();
        rt.push(resp.data());
      } catch (error) {}
      return rt;
    }
  }
};
</script>
